<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cus00104 extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $servicoPorGrupo;
    protected $qr2Strategy;
    protected $crudService;

    public function __construct($reportService, $entityManager, $servicoPorGrupo, $qr2Strategy, $crudService) {

        $this->entityManager    = $entityManager;
        $this->servicoPorGrupo  = $servicoPorGrupo;
        $this->qr2Strategy      = $qr2Strategy;
        $this->reportService    = $reportService;
        $this->crudService      = $crudService;
    }

    protected $reportMapping = array (
        'cus00104' => 
        array (
        'strategy' => 'QR2',
        'parameterMapping' => 
            array (
            'CDFILIAL'    => 'P_CDFILIAL',
            'LISTASERV'   => 'P_CDSERVFILI',
            'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
            'NMTIPOCUSTO' => 'P_NMCUSTO',
            'DTINICIAL'   => 'P_DTINICIAL',
            'DTFINAL'     => 'P_DTFINAL',
            'LISTADIETA'  => 'P_CDDIETPAD',
            'TCDIETPAD'   => 'P_TCDDIETPAD',
            ),
        ),
        'cus00105' => 
        array (
        'strategy' => 'QR2',
        'parameterMapping' => 
            array (
            'CDFILIAL'    => 'P_CDFILIAL',
            'LISTASERV'   => 'P_CDSERVFILI',
            'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
            'NMTIPOCUSTO' => 'P_NMCUSTO',
            'DTINICIAL'   => 'P_DTINICIAL',
            'DTFINAL'     => 'P_DTFINAL',
            'LISTADIETA'  => 'P_CDDIETPAD',
            'TCDIETPAD'   => 'P_TCDDIETPAD',
            ),
        ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $cdoperador = $row['CDOPERADOR'];
        $cdfilial = $row['CDFILIAL'];
        $nrorg = $row['NRORG'];
        $cdgrupserv = $row['LISTAGRUPSERV'];
        
        if($cdgrupserv == 'T'){
            $conditions = array();
            $gruposerv = $this->crudService->getFilteredDataSet('grupserv', $conditions)->getRows();
            $cdgrupserv = [];

            foreach ($gruposerv as $value) {
                array_push($cdgrupserv, $value["CDGRUPSERV"]);
            }

            $row["LISTAGRUPSERV"] = implode('_', $cdgrupserv);
            $cdgrupserv = $row["LISTAGRUPSERV"];
        }

        if ($row['LISTASERV'] == 'T') {
            $row['LISTASERV'] = $this->servicoPorGrupo->retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv);
        }

    }
}