<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Cus00700 extends \Zeedhi\Framework\Controller\Report {
    
    protected $qr2Strategy;
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $servicoPorGrupo, $unidades, $qr2Strategy, $birtStrategy, $util) {

      $this->servicoPorGrupo = $servicoPorGrupo;
      $this->unidades        = $unidades;
      $this->qr2Strategy     = $qr2Strategy;
      $this->birtStrategy    = $birtStrategy;
      $this->reportService   = $reportService;
      $this->util            = $util;
    }

    protected $reportMapping = array (
  'CUS00700' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'DTULTDIA'      => 'P_DTULTDIA', 
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'DTMESANTEINI'  => 'P_DTMESANTEINI',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00701' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'DTULTDIA'      => 'P_DTULTDIA', 
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'DTMESANTEINI'  => 'P_DTMESANTEINI',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00702' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'DTULTDIA'      => 'P_DTULTDIA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'DTMESANTEINI'  => 'P_DTMESANTEINI',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00703' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00704' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00705' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'CDPICTPRAT'    => 'P_CDPICTPRAT',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00706' => 
  array (
   'strategy' => 'BIRT',
   'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'CDPICTPRAT'    => 'P_CDPICTPRAT',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00707' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'CDPICTPRAT'    => 'P_CDPICTPRAT',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00708' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'CDPICTPRAT'    => 'P_CDPICTPRAT',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS00709' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'CDPICTPRAT'    => 'P_CDPICTPRAT',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS0070B' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'CDALLFILI'     => 'P_CDALLFILI',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS0070C' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'CDALLFILI'     => 'P_CDALLFILI',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'NRORG'         => 'P_NRORG'
    ),
  ),
   'CUS0070D' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'CDALLFILI'     => 'P_CDALLFILI',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS0070F' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'NRORG'         => 'P_NRORG'
    ),
  ),
   'CUS0070I' => 
  array (
    'strategy' => 'BIRT',
    'parameterMapping' => 
    array (
      'CDFILIAL'      => 'P_CDFILIAL',
      'LISTASERV'     => 'P_NRLISTASERV',
      'NMTIPOCUSTO'   => 'P_NMCUSTO',
      'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',
      'DTINICIAL'     => 'P_DATAINIC',
      'DTFINAL'       => 'P_DATAFINA', 
      'DTPERIINIC'    => 'P_DTPERIINIC',
      'DTPERIFINA'    => 'P_DTPERIFINA',
      'DTULTDIA'      => 'P_DTULTDIA', 
      'IDESTOCAVEL'   => 'P_IDESTOCAVEIS',
      'IDNAOESTOC'    => 'P_IDNAOESTOC',
      'DTMESINIC'     => 'P_DTMESINIC',
      'DTMESFINA'     => 'P_DTMESFINA',    
      'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL', 
      'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
      'DTMESANTEINI'  => 'P_DTMESANTEINI',
      'LISTAGRUPSERV' => 'P_CDGRUPSERV',
      'CDPICTPROD'    => 'P_CDPICTPROD',
      'NRORG'         => 'P_NRORG'
    ),
  ),
  'CUS0070E' => 
  array (
    'strategy' => 'QR2',
    'parameterMapping' => 
    array (),
  ),
  'CUS0070A' => 
  array (
    'strategy' => 'QR2',
    'parameterMapping' => 
    array (),
  )
);

    //Função para verificar se existe algum grupo sem seviços cadastrados.
    public function validaGrupoServico($nrorg, $cdfilial, $cdoperador, $cdgrupserv, $cdgrupfili = null) {

        $cdgrupserv = explode('_', $cdgrupserv);

        $gruposServico = array();
        $grupoVazio = array();
        $grupoValido = array();
        
            foreach ($cdgrupserv as $cdgrupservs) {
    
                $gruposServico = $this->servicoPorGrupo->retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupservs, $cdgrupfili);
                
                if(!$gruposServico){
                    $grupoVazio[] =  $cdgrupservs;
                }else{
                    $grupoValido[] = $cdgrupservs;
                }
            }
        if($grupoValido) {
            return implode("_", $grupoValido);
        }else{
            throw new \Exception('Não existe Serviços cadastrado nesse grupo!');
            
        }   
       
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
          
        $cdfilial   = $row['CDFILIAL'];
        $nrorg      = $row['NRORG'];
        $cdoperador = $row['CDOPERADOR'];
        $cdgrupserv = $row ['LISTAGRUPSERV'];

        $validaGrupoComServico = $this->validaGrupoServico($nrorg, $cdfilial, $cdoperador, $cdgrupserv);
        //Atribui somente grupos que tem serviços cadastrados a variavel $cdgrupserv.
        $cdgrupserv = $validaGrupoComServico;

        if ($row['LISTASERV'] == 'REQUEST') {
            $row['LISTASERV'] = $this->servicoPorGrupo->retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv);
        }
        $nrlistaserv = $this->util->insertLista(explode('_',$row['LISTASERV']));
        $row['LISTASERV'] = $nrlistaserv;
        if($row['REPORT_NAME'] == 'CUS0070B' || $row['REPORT_NAME'] == 'CUS0070C' || $row['REPORT_NAME'] == 'CUS0070D'){
           if($row['CDALLFILI'] == 'T'){
              $row['CDALLFILI'] = $this->unidades->retornaUnidades($nrorg, $cdoperador);     
              $row['CDALLFILI'] = explode('_',$row['CDALLFILI']);
           }
              $nrlistafilial = $this->util->insertLista($row['CDALLFILI']);
              $row['CDALLFILI'] = $nrlistafilial;
         }
         
    }
    // public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
    //   $row = $request->getRow();
    //   $this->util->deleteLista($row['LISTASERV']);
    // }
}