<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;

class Cus01000 extends \Zeedhi\Framework\Controller\Report {
    
    protected $reportMapping = array (
        'CUS01000' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NMTIPOCUSTO'  => 'P_NMCUSTO',
                'CDFILICUSTO'  => 'P_CDFILICUSTO',
                'CDTIPOCUSTO'  => 'P_NRTIPOCUSTO',
                'DTCUSTO'      => 'P_DTCUSTO',
                'CDTIPORECE'   => 'P_TIPORECE',
                'CDPRATOINI'   => 'P_CDPRATOINI',
                'CDPRATOFIM'   => 'P_CDPRATOFIM',
                'CDNVPRATO'    => 'P_CDNVPRATO',
                'CDFILIAL'     => 'P_CDFILIAL',
                'CDSERVFILI'   => 'P_CDSERVFILI',
                'CDTIPOCARD'   => 'P_CDTIPOCARD',
                'CDFILCENTPME' => 'P_CDFILCENTPME',
                'NRTAMACNIVEL' => 'P_NRTAMACNIVEL',
                'ORDENAPROD'   => 'P_ORDENAPROD',
                'CDPICTPRAT'   => 'P_CDPICTPRAT',
                'NRORG'        => 'P_NRORG',
            ),
        ),
    );
    
    protected $birtStrategy;

    public function __construct($reportService, $birtStrategy) {
        $this->reportService    = $reportService;
        $this->birtStrategy     = $birtStrategy;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $row['CDFILICUSTO']=$row['CDFILIAL'];
        $tamanho = 10;
        $completaCom = 'z';
        $row['CDPRATOFIM'] = str_pad($row['CDPRATOFIM'], $tamanho, $completaCom, STR_PAD_RIGHT);
    }
}